numHeads 	equ	guiHeadVars
selItem		equ	guiHeadVars+1
startHData 	equ	guiHeadVars+2
selDataAddr	equ	guiHeadVars+4
selDataType equ	guiHeadVars+6

StartHead:
 B_CALL	ClrLCDFull
 ld		hl,0000h
 ld		(curRow),hl
 pop		hl
 ld		a,(hl)
 ld		(numHeads),a
 ld		b,a
 inc		hl							; Over number
 ld		a,(hl)
 ld		(selItem),a
 inc		hl							; Over initial
 ld		(startHData),hl

DrawHead:
 call		GetDataAddr
 inc		hl							; Over the address of the data structure
 inc		hl							; 
 call		SetHeadInverse
 call		DrawString
 ld		a,20h
 res		textInverse, (IY+textFlags)
 B_CALL	PutC

sh0:
 inc		hl
 ld		a,(hl)
 or		a
 jr		z,sh1
 jr		sh0

sh1:
 inc		hl							; Over NULL
 djnz		DrawHead

 ld		hl,(selDataAddr)

 ld		a,(selDataType)
 
 ifdef  _guiMenu_
 cp		guiMenu
 jr		z,HMenu
 endif
 ifdef  _guilist_
 cp		guiList
 jr		z,HList
 endif

GetDataAddr:
 ld		a,(numHeads)
 ld		c,b
 sub		a,c
 ld		c,a
 ld		a,(selItem)
 dec		a
 cp		c
 jr		z,gda0
 inc		hl							; Over the type
 ret		
gda0:
 ld		a,(hl)					; Get the type
 ld		(selDataType),a		; Store the type
 inc		hl							; Over the type
 push		hl							; Push the address
 ex		de,hl						; Exchange DE and HL
 ld		a,(de)					; Load the first byte 
 ld		l,a						; Into L
 inc		de							; Increment it
 ld		a,(de)					; Load the second byte
 ld		h,a						; Into H
 ld		(selDataAddr),hl		; Store the jump address
 pop		hl							; Pop the address
 ret 									; Return to the loop

 ifdef _guiMenu_
 HMenu:
 push		hl
 jp		StartMenu 
 endif

 ifdef _guiList_
 HList:
 push		hl
 jp		StartList
 endif

GuiHeadLeft:
 ld		a,(selItem)
 cp		1
 jr		z,ghl0
 jr		ghl1

ghl0:
 ld		a,(numHeads)
 jr		HSelectDraw

ghl1:
 dec		a
 ld		(selItem),a
 jr		HSelectDraw

GuiHeadRight:
 ld		a,(selItem)
 ld		b,a
 ld		a,(numHeads)
 cp		b
 jr		z,ghr0
 jr		ghr1

ghr0:
 ld		a,1
 jr		HSelectDraw

ghr1:
 ld		a,b
 inc		a

HSelectDraw:
 ld		(selItem),a
 ld		a,(numHeads)
 ld		b,a
 ld		hl,0000h
 ld		(curRow),hl
 ld		hl,(startHData)
 jp		DrawHead

SetHeadInverse:
 ld		a,(numHeads)
 ld		c,b
 sub		a,c
 ld		c,a
 ld		a,(selItem)
 dec		a
 cp		c
 jr		z,shi0
 res		textInverse, (IY+textFlags)
 ret
shi0:
 set		textInverse, (IY+textFlags)
 ret


